<!DOCTYPE html>

<html lang="en" data-content_root="./">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>sagace.auth.infrastructure package &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="_static/alabaster.css?v=27fed22d" />
    <script src="_static/documentation_options.js?v=cb975c41"></script>
    <script src="_static/doctools.js?v=9bcbadda"></script>
    <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="sagace.auth.interfaces package" href="sagace.auth.interfaces.html" />
    <link rel="prev" title="sagace.auth.domain package" href="sagace.auth.domain.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="sagace-auth-infrastructure-package">
<h1>sagace.auth.infrastructure package<a class="headerlink" href="#sagace-auth-infrastructure-package" title="Link to this heading">¶</a></h1>
<section id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Link to this heading">¶</a></h2>
</section>
<section id="module-sagace.auth.infrastructure.authentication_api">
<span id="sagace-auth-infrastructure-authentication-api-module"></span><h2>sagace.auth.infrastructure.authentication_api module<a class="headerlink" href="#module-sagace.auth.infrastructure.authentication_api" title="Link to this heading">¶</a></h2>
<hr class="docutils" />
<section id="descricao">
<h3>Descrição:<a class="headerlink" href="#descricao" title="Link to this heading">¶</a></h3>
<p>Este módulo implementa a autenticação de usuários no sistema SAGACE utilizando uma API externa.
A classe <cite>AuthenticationAPI</cite> herda de <cite>AuthenticationRepository</cite>, garantindo a conformidade com o princípio de <strong>Dependency Inversion</strong> (D do SOLID),
permitindo a substituição da implementação sem afetar os consumidores da interface.</p>
<p>Principais funcionalidades:</p>
<ul class="simple">
<li><p>Realiza autenticação via API externa.</p></li>
<li><p>Armazena o token JWT utilizando <cite>TokenStorage</cite>.</p></li>
<li><p>Lança exceções apropriadas em caso de falha.</p></li>
</ul>
<p>Classes:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">AuthenticationAPI</span></code>: Implementação do repositório de autenticação via API.</p></li>
</ul>
<p>Exemplo de uso:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span><span class="w"> </span><span class="nn">sagace.infrastructure</span><span class="w"> </span><span class="kn">import</span> <span class="n">AuthenticationAPI</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">sagace.core</span><span class="w"> </span><span class="kn">import</span> <span class="n">TokenStorage</span>

<span class="n">auth_api</span> <span class="o">=</span> <span class="n">AuthenticationAPI</span><span class="p">()</span>
<span class="n">token_storage</span> <span class="o">=</span> <span class="n">TokenStorage</span><span class="p">()</span>
<span class="n">token</span> <span class="o">=</span> <span class="n">auth_api</span><span class="o">.</span><span class="n">authenticate</span><span class="p">(</span><span class="s2">&quot;https://api.sagace.online&quot;</span><span class="p">,</span> <span class="s2">&quot;usuario&quot;</span><span class="p">,</span> <span class="s2">&quot;senha&quot;</span><span class="p">,</span> <span class="s2">&quot;app_token&quot;</span><span class="p">,</span> <span class="n">token_storage</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">token</span><span class="p">)</span>
</pre></div>
</div>
<p>Autor: Diego Yosiura
Última Atualização: 27/02/2025 15:31
Criado em: 27/02/2025 15:31
Copyright: (c) Ampere Consultoria Ltda
Projeto Original: sagace-v2-package
IDE: PyCharm</p>
</section>
<dl class="py class">
<dt class="sig sig-object py" id="sagace.auth.infrastructure.authentication_api.AuthenticationAPI">
<em class="property"><span class="k"><span class="pre">class</span></span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">sagace.auth.infrastructure.authentication_api.</span></span><span class="sig-name descname"><span class="pre">AuthenticationAPI</span></span><a class="reference internal" href="_modules/sagace/auth/infrastructure/authentication_api.html#AuthenticationAPI"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#sagace.auth.infrastructure.authentication_api.AuthenticationAPI" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference internal" href="sagace.auth.domain.html#sagace.auth.domain.authentication_repository.AuthenticationRepository" title="sagace.auth.domain.authentication_repository.AuthenticationRepository"><code class="xref py py-class docutils literal notranslate"><span class="pre">AuthenticationRepository</span></code></a></p>
<p>Implementação da autenticação via API externa.</p>
<p>Esta classe implementa <cite>AuthenticationRepository</cite>, garantindo que qualquer mudança na forma
de autenticação possa ser feita sem impactar os consumidores desta interface.</p>
<p>Princípios utilizados:
- <strong>Dependency Inversion (D - SOLID)</strong>: Utiliza uma abstração (<cite>AuthenticationRepository</cite>) para evitar dependências diretas.
- <strong>Single Responsibility (S - SOLID)</strong>: Responsável exclusivamente por autenticação via API.
- <strong>Clean Architecture</strong>: Implementação no nível de infraestrutura, garantindo separação entre domínio e serviços externos.</p>
<dl class="py attribute">
<dt class="sig sig-object py" id="sagace.auth.infrastructure.authentication_api.AuthenticationAPI.AUTH_URL">
<span class="sig-name descname"><span class="pre">AUTH_URL</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">'auth/base/login/'</span></em><a class="headerlink" href="#sagace.auth.infrastructure.authentication_api.AuthenticationAPI.AUTH_URL" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="sagace.auth.infrastructure.authentication_api.AuthenticationAPI.BASE_URL">
<span class="sig-name descname"><span class="pre">BASE_URL</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">'https://demo.sagace.online/'</span></em><a class="headerlink" href="#sagace.auth.infrastructure.authentication_api.AuthenticationAPI.BASE_URL" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="sagace.auth.infrastructure.authentication_api.AuthenticationAPI._abc_impl">
<span class="sig-name descname"><span class="pre">_abc_impl</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">&lt;_abc._abc_data</span> <span class="pre">object&gt;</span></em><a class="headerlink" href="#sagace.auth.infrastructure.authentication_api.AuthenticationAPI._abc_impl" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="sagace.auth.infrastructure.authentication_api.AuthenticationAPI.authenticate">
<span class="sig-name descname"><span class="pre">authenticate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">base_url</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">username</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">password</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">token</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">token_storage</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="sagace.core.html#sagace.core.token_storage.TokenStorage" title="sagace.core.token_storage.TokenStorage"><span class="pre">TokenStorage</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="sagace.core.html#sagace.core.token.Token" title="sagace.core.token.Token"><span class="pre">Token</span></a></span></span><a class="reference internal" href="_modules/sagace/auth/infrastructure/authentication_api.html#AuthenticationAPI.authenticate"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#sagace.auth.infrastructure.authentication_api.AuthenticationAPI.authenticate" title="Link to this definition">¶</a></dt>
<dd><p>Autentica um usuário via API e retorna um token JWT.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>base_url</strong> (<em>str</em>) – URL base da API de autenticação.</p></li>
<li><p><strong>username</strong> (<em>str</em>) – Nome de usuário para autenticação.</p></li>
<li><p><strong>password</strong> (<em>str</em>) – Senha do usuário.</p></li>
<li><p><strong>token</strong> (<em>str</em>) – Token da aplicação para autenticação.</p></li>
<li><p><strong>token_storage</strong> (<a class="reference internal" href="sagace.core.html#sagace.core.token_storage.TokenStorage" title="sagace.core.token_storage.TokenStorage"><em>TokenStorage</em></a>) – Instância responsável por armazenar o token JWT.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Token JWT retornado pela API.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p><a class="reference internal" href="sagace.core.html#sagace.core.token.Token" title="sagace.core.token.Token">Token</a></p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><a class="reference internal" href="sagace.exceptions.domain.html#sagace.exceptions.domain.api_request_error.APIRequestError" title="sagace.exceptions.domain.api_request_error.APIRequestError"><strong>APIRequestError</strong></a> – Se a API retornar um erro na requisição.</p></li>
<li><p><a class="reference internal" href="sagace.exceptions.infrastructure.html#sagace.exceptions.infrastructure.authentication_error.AuthenticationFailedError" title="sagace.exceptions.infrastructure.authentication_error.AuthenticationFailedError"><strong>AuthenticationFailedError</strong></a> – Se os dados esperados não estiverem presentes na resposta.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</dd></dl>

</section>
<section id="module-sagace.auth.infrastructure">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-sagace.auth.infrastructure" title="Link to this heading">¶</a></h2>
<hr class="docutils" />
<section id="description">
<h3>Description:<a class="headerlink" href="#description" title="Link to this heading">¶</a></h3>
<p>Obs.:</p>
<p>Author:           &#64;diego.yosiura
Last Update:      27/02/2025 15:29
Created:          27/02/2025 15:29
Copyright:        (c) Ampere Consultoria Ltda
Original Project: sagace-v2-package
IDE:              PyCharm</p>
</section>
</section>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="modules.html">sagace</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="sagace.html">sagace package</a></li>
</ul>
</li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
  <li><a href="modules.html">sagace</a><ul>
  <li><a href="sagace.html">sagace package</a><ul>
  <li><a href="sagace.auth.html">sagace.auth package</a><ul>
      <li>Previous: <a href="sagace.auth.domain.html" title="previous chapter">sagace.auth.domain package</a></li>
      <li>Next: <a href="sagace.auth.interfaces.html" title="next chapter">sagace.auth.interfaces package</a></li>
  </ul></li>
  </ul></li>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
      |
      <a href="_sources/sagace.auth.infrastructure.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>